from setuptools import setup, find_packages

setup(
    name="EasyDeL",
    version="0.0.42",
    author="Erfan Zare Chavoshi",
    author_email="erfanzare82@eyahoo.com",
    description="An open-source library to make training faster and more optimized in Jax/Flax",
    url="https://github.com/erfanzar/EasyDeL",
    packages=find_packages("lib/python"),
    long_description=open("README.md").read(),
    long_description_content_type="text/markdown",
    classifiers=[
        "Development Status :: 3 - Alpha",
        "Intended Audience :: Developers",
        "Topic :: Scientific/Engineering :: Artificial Intelligence",
        "License :: OSI Approved :: Apache Software License",
        "Programming Language :: Python :: 3",
        "Programming Language :: Python :: 3.8",
        "Programming Language :: Python :: 3.9",
        "Programming Language :: Python :: 3.10",
        "Programming Language :: Python :: 3.11",
        "Programming Language :: Python :: 3.12",
    ],
    keywords="machine learning, deep learning, pytorch, jax, flax",
    install_requires=[
        "chex~=0.1.84",
        "typing~=3.7.4.3",
        "jax>=0.4.17",
        "jaxlib>=0.4.17",
        "flax~=0.7.5",
        "fjformer>=0.0.25",
        "transformers>=4.33.0",
        "einops~=0.6.1",
        "optax~=0.1.7",
        "msgpack~=1.0.7",
        "ipython~=8.17.2",
        "tqdm~=4.64.1",
        "pydantic==2.5.3",
        "datasets~=2.14.6",
        "setuptools~=68.1.2",
        "gradio~=4.12.0",
        "distrax",
        "rlax",
        "termcolor",
        "wandb>=0.15.9",
        "tensorboard",
        "torch~=2.1.0",
        "numpy~=1.26.2",
        "uvicorn~=0.23.2",
        "fastapi~=0.104.1",
        "pydantic-core==2.14.6"
    ],
    python_requires=">=3.8",
    package_dir={"": "lib/python"},

)
